import { buildUUID } from '../../../utils/uuid';
import { ApiActionPage } from '../../model/baseModel';
import {
  ShelfListItem,
  ShelfPageParams,
  ShelfPageListGetResultModel,
} from '../model/warehoueseModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';

/*
 * 获取货架分页列表
 */
export const getShelfListByPage = async (params: ShelfPageParams) => {
  let sqlcmd = '';
  if (params?.REGION_CODE != undefined && params?.REGION_CODE != '') {
    sqlcmd += " And REGION_CODE like '%" + params?.REGION_CODE + "%'";
  }
  if (params?.SHELF_CODE != undefined && params?.SHELF_CODE != '') {
    sqlcmd += " And SHELF_CODE = '" + params?.SHELF_CODE + "'";
  }
  if (params?.SHELF_NAME != undefined && params?.SHELF_NAME != '') {
    sqlcmd += "And SHELF_NAME like '%" + params?.SHELF_NAME + "%'";
  }
  if (params?.IS_CAR != undefined && params?.IS_CAR != '') {
    sqlcmd += "And IS_CAR = '" + params?.IS_CAR + "'";
  }
  if (params?.SHELF_TYPE != undefined) {
    sqlcmd += "And SHELF_TYPE = '" + params?.SHELF_TYPE + "'";
  }
  const rParams = genActionPage('WMS_SHELF', sqlcmd, params.page, params.pageSize);
  return getShelfListByPageAsync(rParams);
};
async function getShelfListByPageAsync(params: ApiActionPage) {
  const data = await defHttp.post<ApiActionPage>(
    { url: Api.EntityPageList, params },
    {
      isTransformResponse: false,
    },
  );
  const model: ShelfPageListGetResultModel = {
    items: data.Data.data,
    total: data.Data.totals,
  };
  return model;
}

export const SaveShelf = async (params: ShelfListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('WMS_SHELF', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('WMS_SHELF', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};

export const DeleteShelf = async (params: Recordable) => {
  const usParams = genAction('WMS_SHELF', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
